SystemOrganization addCategory: #'Volunti-ElectionClient-Config'!
SystemOrganization addCategory: #'Volunti-ElectionClient-Model'!
SystemOrganization addCategory: #'Volunti-ElectionClient-View'!
SystemOrganization addCategory: #'Volunti-ElectionClient-Accessibility-View'!
SystemOrganization addCategory: #'Volunti-ElectionClient-Mobile-View'!
SystemOrganization addCategory: #'Volunti-ElectionClient-Tests'!

VOEntry subclass: #VODigipass
	instanceVariableNames: 'rsaPk rsaSk pin certificate confirmationPin anonymousSk anonymousPk'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-ElectionClient-Model'!

VODigipass class
	instanceVariableNames: 'digipasses'!

VODigipass class
	instanceVariableNames: 'digipasses'!

!VODigipass class methodsFor: 'adding' stamp: 'NicolasVanderAuwera 11/20/2012 09:29'!
add: aDigipass
	self digipasses add: aDigipass! !

!VODigipass class methodsFor: 'instance creation' stamp: 'NicolasVanderAuwera 5/3/2012 06:28'!
certificate: cert rsaSk: sk rsaPk: pk
	^ self new certificate: cert rsaSk: sk rsaPk: pk! !

!VODigipass class methodsFor: 'examples' stamp: 'NicolasVanderAuwera 2/21/2012 14:52'!
createSample
	| generator digipass |
	1 to: 1
		do: [ :i |
			generator := RSAKeyPairGenerator bits: 1024.
			digipass := self new
				rsaPk: generator publicKey;
				rsaSk: generator privateKey;
				pin: 1000 + i;
				yourself.
			self digipasses add: digipass ]! !

!VODigipass class methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 11/20/2012 09:30'!
digipasses
	^ digipasses ifNil: [ digipasses := OrderedCollection new ]! !

!VODigipass class methodsFor: 'enumerating' stamp: 'NicolasVanderAuwera 11/20/2012 09:29'!
withPin: anInteger
	^ digipasses detect: [ :each | each pin = anInteger ] ifNone: [ nil ]! !

!VODigipass methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 8/2/2012 14:59'!
anonymousPk
	^ anonymousPk! !

!VODigipass methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 8/2/2012 14:59'!
anonymousPk: anObject
	anonymousPk := anObject! !

!VODigipass methodsFor: 'process' stamp: 'NicolasVanderAuwera 8/3/2012 08:35'!
anonymousSignature: m
	^ anonymousSk crypt: m! !

!VODigipass methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 8/2/2012 14:59'!
anonymousSk
	^ anonymousSk! !

!VODigipass methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 8/2/2012 14:59'!
anonymousSk: anObject
	anonymousSk := anObject! !

!VODigipass methodsFor: 'process' stamp: 'NicolasVanderAuwera 2/4/2012 16:30'!
blind: integer
	^ rsaPk crypt: integer! !

!VODigipass methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 5/3/2012 06:29'!
certificate
	^ certificate! !

!VODigipass methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 5/3/2012 06:29'!
certificate: anObject
	certificate := anObject! !

!VODigipass methodsFor: 'initialize-release' stamp: 'NicolasVanderAuwera 5/3/2012 06:29'!
certificate: cert rsaSk: sk rsaPk: pk
	certificate := cert.
	rsaPk := pk.
	rsaSk := sk! !

!VODigipass methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 5/3/2012 16:02'!
confirmationPin: anInteger
	confirmationPin := anInteger! !

!VODigipass methodsFor: 'defaults' stamp: 'NicolasVanderAuwera 2/21/2012 14:51'!
defaultPinLength
	^ 5! !

!VODigipass methodsFor: 'descriptions' stamp: 'NicolasVanderAuwera 11/20/2012 09:34'!
descriptionConfirmationPin
	<magritteDescription>
	^ MANumberDescription new
		accessor: #confirmationPin;
		label: 'Confirmation of pin code';
		yourself! !

!VODigipass methodsFor: 'descriptions' stamp: 'NicolasVanderAuwera 11/20/2012 09:35'!
descriptionContainer
	^ super descriptionContainer
		addCondition: [ :memento | 
					(memento cache at: self descriptionPin) isNil
						or: [ (memento cache at: self descriptionPin) = (memento cache at: self descriptionConfirmationPin) ] ]
			labelled: 'Pin must match';
		yourself! !

!VODigipass methodsFor: 'descriptions' stamp: 'NicolasVanderAuwera 11/20/2012 09:37'!
descriptionPin
	<magritteDescription>
	^ MANumberDescription new
		accessor: #pin;
		label: 'Pin code';
		addCondition: [ :value | (self class withPin: value) notNil ] labelled: 'Incorrect pin';
		yourself! !

!VODigipass methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 5/3/2012 16:49'!
pin
	^ pin! !

!VODigipass methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 1/23/2012 15:11'!
pin: anObject
	pin := anObject! !

!VODigipass methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 1/23/2012 15:11'!
rsaPk
	^ rsaPk! !

!VODigipass methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 1/23/2012 15:11'!
rsaPk: anObject
	rsaPk := anObject! !

!VODigipass methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 1/23/2012 15:11'!
rsaSk
	^ rsaSk! !

!VODigipass methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 1/23/2012 15:11'!
rsaSk: anObject
	rsaSk := anObject! !

!VODigipass methodsFor: 'process' stamp: 'NicolasVanderAuwera 5/10/2012 14:40'!
sign: anInteger
	^ rsaSk crypt: anInteger! !

!VODigipass methodsFor: 'process' stamp: 'NicolasVanderAuwera 2/4/2012 16:30'!
unblind: integer
	^ rsaSk crypt: integer! !

VOSession subclass: #VOElectionClientSession
	instanceVariableNames: 'electionClient user election fontSize protocol theme backColor textColor accessibility'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-ElectionClient-Config'!

!VOElectionClientSession methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 2/21/2012 09:23'!
accessibility
	^ accessibility ifNil: [ accessibility := false ]! !

!VOElectionClientSession methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 2/21/2012 09:19'!
accessibility: anObject
	accessibility := anObject! !

!VOElectionClientSession methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 2/20/2012 09:16'!
backColor
	^ backColor ifNil: [ backColor := self defaultBackColor ]! !

!VOElectionClientSession methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 2/20/2012 09:12'!
backColor: anObject
	backColor := anObject! !

!VOElectionClientSession methodsFor: 'user interface' stamp: 'NicolasVanderAuwera 2/13/2012 08:54'!
decrementFontSize
	fontSize := self fontSize - 1! !

!VOElectionClientSession methodsFor: 'defaults' stamp: 'NicolasVanderAuwera 2/20/2012 09:16'!
defaultBackColor
	^ 'blue'! !

!VOElectionClientSession methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 2/21/2012 09:18'!
defaultFontSize
	^ 14! !

!VOElectionClientSession methodsFor: 'defaults' stamp: 'NicolasVanderAuwera 2/20/2012 09:16'!
defaultTextColor
	^ 'yellow'! !

!VOElectionClientSession methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 11/25/2011 17:44'!
electionClient
	^ electionClient ifNil: [ electionClient := VOElectionClient new ]! !

!VOElectionClientSession methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 12/7/2011 14:26'!
elections
	^ self electionClient elections! !

!VOElectionClientSession methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 2/13/2012 09:05'!
fontSize
	fontSize isNil
		ifTrue: [ self resetFontSize ].
	^ fontSize! !

!VOElectionClientSession methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 2/18/2012 12:37'!
fontSize: anInteger
	fontSize := anInteger! !

!VOElectionClientSession methodsFor: 'user interface' stamp: 'NicolasVanderAuwera 2/13/2012 09:04'!
incrementFontSize
	fontSize := self fontSize + 1! !

!VOElectionClientSession methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 11/15/2012 08:21'!
initialize
	super initialize.
	accessibility := false.! !

!VOElectionClientSession methodsFor: 'testing' stamp: 'NicolasVanderAuwera 3/29/2012 13:16'!
isLoggedIn
	^ user notNil! !

!VOElectionClientSession methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 2/5/2012 08:25'!
protocol
	^ protocol! !

!VOElectionClientSession methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 2/5/2012 08:25'!
protocol: aProtocol
	protocol := aProtocol! !

!VOElectionClientSession methodsFor: 'user interface' stamp: 'NicolasVanderAuwera 2/21/2012 09:18'!
resetFontSize
	fontSize := self defaultFontSize! !

!VOElectionClientSession methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 2/20/2012 09:16'!
textColor
	^ textColor ifNil: [ textColor := self defaultTextColor ]! !

!VOElectionClientSession methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 2/20/2012 09:13'!
textColor: anObject
	textColor := anObject! !

!VOElectionClientSession methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 2/18/2012 12:40'!
theme
	^ theme! !

!VOElectionClientSession methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 2/18/2012 12:40'!
theme: anObject
	theme := anObject! !

!VOElectionClientSession methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 2/6/2012 08:43'!
user
	^ self protocol user ! !

!VOElectionClientSession methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 12/31/2011 13:53'!
user: aUser
	user := aUser! !

WATask subclass: #VOBlindingTask
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-ElectionClient-View'!

!VOBlindingTask methodsFor: 'running' stamp: 'NicolasVanderAuwera 8/24/2012 09:06'!
go
	| signature |
	signature := self session protocol
		sendBlindedId: (self request: 'Please enter your blinded id in the field bellow.') greaseInteger.
	self
		call:
			(VOInformDialog
				title: 'The signature on your Blinded ID is the following. Please unblind it with your digipass.'
				body: signature)! !

WATask subclass: #VODigipassTask
	instanceVariableNames: 'digipass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-ElectionClient-View'!

!VODigipassTask methodsFor: 'tasks' stamp: 'NicolasVanderAuwera 1/20/2012 10:22'!
enterId
	^ self request: 'Enter your id'! !

!VODigipassTask methodsFor: 'tasks' stamp: 'NicolasVanderAuwera 1/2/2012 09:06'!
enterPinCode
	^ self call: VOPinCodeFormView new! !

!VODigipassTask methodsFor: 'running' stamp: 'NicolasVanderAuwera 8/20/2012 06:59'!
go
	[ 
	(digipass := self enterPinCode) isNil
		ifFalse: [ 
			self identifyOrSign
				ifTrue: [ self identification ]
				ifFalse: [ self signature ] ] ] repeat! !

!VODigipassTask methodsFor: 'tasks' stamp: 'NicolasVanderAuwera 8/2/2012 15:00'!
identification
	| challenge |
	challenge := (self request: 'Enter the challenge') greaseInteger.
	self showResponseFor: challenge.
	self showBlindedId: (self request: 'Enter your id') greaseInteger.
	self showSignature: (self request: 'Enter the anonymous id')! !

!VODigipassTask methodsFor: 'tasks' stamp: 'NicolasVanderAuwera 8/2/2012 15:01'!
identifyOrSign
	^ self call: VOChoiceDialog new! !

!VODigipassTask methodsFor: 'tasks' stamp: 'NicolasVanderAuwera 5/11/2012 08:55'!
showBlindedId: id
	self
		call:
			((VOInformDialog new)
				title: 'Blinded Id:' translated;
				body: (digipass blind: id);
				yourself)! !

!VODigipassTask methodsFor: 'running' stamp: 'NicolasVanderAuwera 5/11/2012 08:45'!
showResponseFor: challenge
	self
		call:
			((VOInformDialog new)
				title: 'The response is:' translated;
				body: (digipass sign: challenge);
				yourself)! !

!VODigipassTask methodsFor: 'tasks' stamp: 'NicolasVanderAuwera 2/26/2012 14:30'!
showSignature: anonymousId
	self
		call:
			(VOInformDialog new
				title: 'Signature:' translated;
				body: (digipass unblind: anonymousId greaseInteger);
				yourself)! !

!VODigipassTask methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 8/26/2012 09:44'!
signature
	| data nb votes |
	nb := (self request: 'Number of signatures?') greaseInteger.
	votes := self call: (VOFieldsInputView numberOfFields: nb).
	votes doWithIndex: [ :vote :index | votes at: index put: (digipass anonymousSignature: vote) ].
	self call: (VODigipassSignaturesView signatures: votes)! !

!VODigipassTask methodsFor: 'tasks' stamp: 'NicolasVanderAuwera 2/19/2012 14:27'!
vote! !

WATask subclass: #VOECConfigurationTask
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-ElectionClient-View'!

!VOECConfigurationTask methodsFor: 'running' stamp: 'NicolasVanderAuwera 10/29/2012 08:30'!
configuration
	^ VOElectionClient electionManagerConfiguration! !

!VOECConfigurationTask methodsFor: 'running' stamp: 'NicolasVanderAuwera 10/29/2012 08:31'!
go
	self
		twbsInformError: [ :html | 
			html
				strong: 'Error:';
				text: ' The client is not configured. Please configure it before launching the system.' ].
	[ 
	self call: self configuration asComponent addValidatedForm.
	self configuration testConnection.
	self configuration isConfigured
		ifFalse: [ 
			self
				twbsInformError: [ :html | 
					html
						strong: 'The system returns the following error:';
						break;
						text: self configuration errorMsg ] ] ] repeat! !

WATask subclass: #VOECSetupTask
	instanceVariableNames: 'zkauthentication blinding'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-ElectionClient-View'!

!VOECSetupTask methodsFor: 'hooks' stamp: 'NicolasVanderAuwera 8/24/2012 09:12'!
children
	^ Array with: zkauthentication with: blinding! !

!VOECSetupTask methodsFor: 'running' stamp: 'NicolasVanderAuwera 8/24/2012 09:12'!
go
	self call: zkauthentication.
	self inform: 'Your id is: ' , (SecureRandom new nextFrom: 10000 to: 99999) greaseString.
	self call: blinding! !

!VOECSetupTask methodsFor: 'initialization' stamp: 'NicolasVanderAuwera 8/24/2012 09:12'!
initialize
	super initialize.
	zkauthentication := VOZKAuthenticationTask new.
	blinding := VOBlindingTask new! !

WATask subclass: #VOECSimpleVoteProcessTask
	instanceVariableNames: 'protocol election'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-ElectionClient-View'!

VOECSimpleVoteProcessTask subclass: #VOECAnonymousVoteProcessTask
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-ElectionClient-View'!

!VOECAnonymousVoteProcessTask methodsFor: 'tasks' stamp: 'NicolasVanderAuwera 10/30/2012 14:36'!
announceTips
	self session announcer
		announce:
			(RefreshTips
				tips: (VOTipsComponent text: 'Enter your identifier and the signature provided by the anonymous authority.'))! !

!VOECAnonymousVoteProcessTask methodsFor: 'tasks' stamp: 'NicolasVanderAuwera 8/20/2012 07:03'!
checkSignature: user
	"^ protocol checkSignature: user"

	^ true! !

!VOECAnonymousVoteProcessTask methodsFor: 'tasks' stamp: 'NicolasVanderAuwera 10/30/2012 14:36'!
identification
	| checked user |
	checked := false.
	self announceTips.
	[ checked ]
		whileFalse: [ 
			user := self call: protocol identificationUser asComponent.
			(checked := self checkSignature: user)
				ifFalse: [ self twbsConfirmSuccess: 'The information you provide are wrong.' ] ].
	^ user! !

!VOECAnonymousVoteProcessTask methodsFor: 'tasks' stamp: 'NicolasVanderAuwera 10/28/2012 11:35'!
loginView
	^ VOUserLoginComponent! !

VOECAnonymousVoteProcessTask subclass: #VOECCompleteVoteProcessTask
	instanceVariableNames: 'ballots numberOfFilledVotes user'
	classVariableNames: 'AuthenticationViews'
	poolDictionaries: ''
	category: 'Volunti-ElectionClient-View'!

VOECCompleteVoteProcessTask subclass: #VOECAlternativeVoteProcessTask
	instanceVariableNames: 'secrets'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-ElectionClient-View'!

!VOECAlternativeVoteProcessTask methodsFor: 'tasks' stamp: 'NicolasVanderAuwera 8/4/2012 09:02'!
chooseBallot
	^ self call: (VOChooseAlternativeBallotView ballots: ballots choices: election choices)! !

!VOECAlternativeVoteProcessTask methodsFor: 'tasks' stamp: 'NicolasVanderAuwera 8/23/2012 10:20'!
editBallot: aBallot
	| secret |
	secret := self secrets removeFirst.
	self
		call:
			(VOAlternativeMBBallotTask model: aBallot list: election choices availableSecrets: secret array asOrderedCollection)! !

!VOECAlternativeVoteProcessTask methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 8/23/2012 10:19'!
secrets
	^ secrets ifNil: [ secrets := protocol availableSecrets ]! !

!VOECCompleteVoteProcessTask class methodsFor: 'instance creation' stamp: 'NicolasVanderAuwera 1/22/2012 14:20'!
ballot: aBallot
	^ self new ballot: aBallot! !

!VOECCompleteVoteProcessTask methodsFor: 'tasks' stamp: 'NicolasVanderAuwera 8/23/2012 13:28'!
auditBallotsExcepted: i
	^ protocol
		position: i;
		auditBallotsOf: user! !

!VOECCompleteVoteProcessTask methodsFor: 'tasks' stamp: 'NicolasVanderAuwera 10/28/2012 11:35'!
authentication
	user := self call: (VOUserLoginComponent user: self session protocol user).
	self session user: (self session protocol authenticate: user).
	self session isLoggedIn
		ifFalse: [ self inform: 'The anonymous authority rejected the information you have entered. Please retry.' ]! !

!VOECCompleteVoteProcessTask methodsFor: 'running' stamp: 'NicolasVanderAuwera 3/29/2012 13:16'!
authenticationTask
	[ 
	self authentication.
	self session isLoggedIn ] whileFalse! !

!VOECCompleteVoteProcessTask methodsFor: 'running' stamp: 'NicolasVanderAuwera 11/1/2012 14:15'!
ballotCreation
	| ballot |
	[ 
	ballot := election ballot.
	ballot voterId: user id.
	self editBallot: ballot.
	ballots add: ballot.
	ballots size >= CryptographicParameters maxNumberOfBallots or: [ self confirm: 'Would like to cast your votes.' ] ]
		whileFalse! !

!VOECCompleteVoteProcessTask methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 5/7/2012 09:36'!
ballots
	^ ballots! !

!VOECCompleteVoteProcessTask methodsFor: 'running' stamp: 'NicolasVanderAuwera 8/23/2012 13:24'!
castBallots
	protocol sendBallots: ballots! !

!VOECCompleteVoteProcessTask methodsFor: 'tasks' stamp: 'NicolasVanderAuwera 5/7/2012 12:34'!
chooseBallot
	^ self call: (VOChooseBallotView ballots: ballots choices: election choices)! !

!VOECCompleteVoteProcessTask methodsFor: 'defaults' stamp: 'NicolasVanderAuwera 2/21/2012 09:53'!
defaultNumberOfBallots
	^ 1! !

!VOECCompleteVoteProcessTask methodsFor: 'tasks' stamp: 'NicolasVanderAuwera 8/3/2012 13:56'!
editBallot: aBallot
	self call: (VOMBBallotTask model: aBallot list: election choices)! !

!VOECCompleteVoteProcessTask methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 2/5/2012 07:38'!
election
	^ election! !

!VOECCompleteVoteProcessTask methodsFor: 'running' stamp: 'NicolasVanderAuwera 8/23/2012 14:38'!
go
	| position correct ballot signatures |
	protocol := election protocol.
	protocol id: election id.
	user := self identification.
	(protocol isVoterAlreadyVoted: user)
		ifFalse: [ 
			self ballotCreation.
			self castBallots.
			self call: (VOShowEncryptedVotes ballots: ballots encryptedVotes: protocol encryptedVotes).
			position := self chooseBallot.
			correct := self auditBallotsExcepted: position.
			self call: (VOShowCommitments ballotsToCheck: protocol ballotsToCheck).
			correct
				ifFalse: [ self inform: 'The Polling Office is cheating.' ]
				ifTrue: [ 
					signatures := self signBallot: (protocol encryptedVotes at: position).
					ballot := ballots at: position.
					protocol castBallot: (ballot signatures: signatures).
					self inform: 'Your vote has been successfully submitted.' ] ]
		ifTrue: [ self inform: 'You have already voted.' ]! !

!VOECCompleteVoteProcessTask methodsFor: 'initialization' stamp: 'NicolasVanderAuwera 5/7/2012 09:36'!
initialize
	super initialize.
	numberOfFilledVotes := 0.
	ballots := OrderedCollection new! !

!VOECCompleteVoteProcessTask methodsFor: 'tasks' stamp: 'NicolasVanderAuwera 3/1/2012 16:08'!
showBallot: aBallot
	^ self call: (VOBallotView model: aBallot choices: election choices)! !

!VOECCompleteVoteProcessTask methodsFor: 'tasks' stamp: 'NicolasVanderAuwera 8/25/2012 07:17'!
signBallot: signatures
	^ self call: (VOSignaturesPage model: signatures)! !

!VOECSimpleVoteProcessTask class methodsFor: 'instance creation' stamp: 'NicolasVanderAuwera 8/3/2012 13:48'!
election: anElection
	^ self new election: anElection! !

!VOECSimpleVoteProcessTask methodsFor: 'tasks' stamp: 'NicolasVanderAuwera 8/3/2012 13:57'!
editBallot: aBallot
	self call: (VOBallotEditor model: aBallot choices: election choices)! !

!VOECSimpleVoteProcessTask methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 7/30/2012 14:53'!
election: anElection
	election := anElection! !

!VOECSimpleVoteProcessTask methodsFor: 'running' stamp: 'NicolasVanderAuwera 8/25/2012 11:01'!
go
	| user ballot |
	protocol := election protocol.
	user := self identification.
	ballot :=  election ballot.
	self editBallot: ballot.
	protocol castBallot: ballot.
	self
		call:
			(VOInformDialog
				title: 'Congratulation'
				body: 'You vote has been correctly casted. Please click on the button "ok" to finish the voting phase.')! !

!VOECSimpleVoteProcessTask methodsFor: 'tasks' stamp: 'NicolasVanderAuwera 10/28/2012 11:35'!
identification
	^ self call: (VOUserLoginComponent user: protocol identificationUser)! !

VOECSimpleVoteProcessTask subclass: #VOMVoteProcessTask
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-ElectionClient-Mobile-View'!

!VOMVoteProcessTask methodsFor: 'tasks' stamp: 'NicolasVanderAuwera 8/25/2012 11:04'!
editBallot: aBallot
	self call: (VOMBallotEditor model: aBallot choices: election choices)! !

!VOMVoteProcessTask methodsFor: 'tasks' stamp: 'NicolasVanderAuwera 2/19/2012 14:06'!
loginView
	^ VOMUserLogin! !

GRObject subclass: #VOAnonymousSignature
	instanceVariableNames: 'signatures votes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-ElectionClient-Model'!

!VOAnonymousSignature class methodsFor: 'instance creation' stamp: 'NicolasVanderAuwera 8/6/2012 14:18'!
votes: list 
	^ self new
		votes: list! !

!VOAnonymousSignature methodsFor: 'adding' stamp: 'NicolasVanderAuwera 8/6/2012 14:12'!
addSignature: aNumber
	signatures add: aNumber! !

!VOAnonymousSignature methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 8/6/2012 14:20'!
at: i put: signature
	self signatures at: i put: signature! !

!VOAnonymousSignature methodsFor: 'initialization' stamp: 'NicolasVanderAuwera 8/6/2012 14:11'!
initialize
	super initialize.
	signatures := OrderedCollection new! !

!VOAnonymousSignature methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 8/6/2012 14:19'!
signatures
	^ signatures ifNil: [ signatures := Array new: votes size ]! !

!VOAnonymousSignature methodsFor: 'validation' stamp: 'NicolasVanderAuwera 8/6/2012 14:15'!
validate
	^ (signatures anySatisfy: [ :signature | signature isInteger ]) isEmpty and: [ signatures size = votes size ]! !

!VOAnonymousSignature methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 8/6/2012 14:10'!
votes: list
	votes := list! !

VOElectionsListComponent subclass: #VOECElectionsListComponent
	instanceVariableNames: 'tips'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-ElectionClient-View'!

!VOECElectionsListComponent class methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 8/3/2012 13:55'!
protocols
	^ Dictionary new
		at: 'VOECSimpleProtocol' put: VOECSimpleVoteProcessTask;
		at: 'VOECAnonymousProtocol' put: VOECAnonymousVoteProcessTask;
		at: 'VOECMBProtocol' put: VOECCompleteVoteProcessTask;
		at: 'VOECAlternativeMBProtocol' put: VOECAlternativeVoteProcessTask;
		yourself! !

!VOECElectionsListComponent methodsFor: 'hooks' stamp: 'NicolasVanderAuwera 10/30/2012 15:03'!
children
	^ Array with: tips! !

!VOECElectionsListComponent methodsFor: 'initialization' stamp: 'NicolasVanderAuwera 11/15/2012 08:22'!
initialize
	super initialize.
	tips := VOTipsComponent text: 'Click on the link participate in the row of an election to begin.'.! !

!VOECElectionsListComponent methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 11/15/2012 07:44'!
lastOpenedElection
	^ self elections reverse detect: [ :election | election opened ] ifNone: [ nil ]! !

!VOECElectionsListComponent methodsFor: 'actions' stamp: 'NicolasVanderAuwera 10/30/2012 06:52'!
participate: election
	^ self show: ((self class protocols at: election protocol class name) election: election)! !

!VOECElectionsListComponent methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 10/30/2012 06:52'!
renderAnchorForElection: election On: html
	election opened
		ifTrue: [ 
			html anchor
				class: 'buttons';
				callback: [ self participate: election ];
				with: 'Participate' ]
		ifFalse: [ 
			html anchor
				class: 'buttons';
				callback: [ self setup: election ];
				with: 'Setup' ]! !

!VOECElectionsListComponent methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 11/15/2012 07:44'!
renderContentOn: html
	html
		twbsRow: [ 
			html
				twbsSpan: 9
				with: [ 
					self renderHeroUnitOn: html.
					self renderPresenterOn: html.
					self session elections isEmpty
						ifTrue: [ html paragraph: 'No election available' ]
						ifFalse: [ self renderElectionsOn: html ] ].
			html twbsSpan: 3 with: tips ]! !

!VOECElectionsListComponent methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 11/15/2012 07:46'!
renderHeroUnitOn: html
	self lastOpenedElection
		ifNotNil: [ 
			html div
				class: 'hero-unit';
				with: [ 
							html heading
								level2;
								with: 'New opened election!!'.
							html
								paragraph: [ 
									html
										text: 'It is named ';
										strong: self lastOpenedElection name;
										text: '. Click on the button to participate.' ].
							html
								paragraph: [ 
									html anchor
										class: 'btn btn-success btn-large';
										callback: [ self participate: self lastOpenedElection ];
										with: 'Participate' ] ] ]! !

!VOECElectionsListComponent methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 11/15/2012 08:22'!
renderMoreData: election on: html
	html
		tableData: [ 
			self renderAnchorForElection: election On: html.
			election protocol isSimple
				ifTrue: [ 
					html space.
					self renderResultsFor: election On: html ] ].
	html
		tableData: [ 
			html anchor
				callback: [ self call: (VOElectionComponent with: election) ];
				with: 'View' ]! !

!VOECElectionsListComponent methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 11/15/2012 08:22'!
renderMoreDataHeadingOn: html
	html tableHeading: 'Action'.
	html tableHeading: 'Details'! !

!VOECElectionsListComponent methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 10/30/2012 06:45'!
renderPresenterOn: html
	html
		paragraph: [ 
			html text: 'Welcome on the Internet Voting Platform '.
			html strong: 'iVolunti'.
			html text: '!! All available elections are listed below.' ]! !

!VOECElectionsListComponent methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 5/5/2012 09:16'!
renderResultsFor: election On: html
	html anchor
		callback: [ self showResultsFor: election ];
		with: 'Results'! !

!VOECElectionsListComponent methodsFor: 'initialization' stamp: 'NicolasVanderAuwera 8/24/2012 08:46'!
setup: election
	self storeProtocolInSession: election.
	self call: VOECSetupPage new! !

!VOECElectionsListComponent methodsFor: 'actions' stamp: 'NicolasVanderAuwera 8/22/2012 13:26'!
showResultsFor: anElection
	self call: (VOResultsPage results: anElection results candidates: anElection choices)! !

!VOECElectionsListComponent methodsFor: 'actions' stamp: 'NicolasVanderAuwera 8/2/2012 14:27'!
storeProtocolInSession: election
	self session protocol: election protocol! !

VORootComponent subclass: #VOElectionClientComponent
	instanceVariableNames: 'content configuration'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-ElectionClient-View'!

VOElectionClientComponent class
	instanceVariableNames: 'digipass'!

VOElectionClientComponent class
	instanceVariableNames: 'digipass'!

!VOElectionClientComponent class methodsFor: 'class initialization' stamp: 'NicolasVanderAuwera 10/30/2012 06:18'!
initialize
	(WAAdmin register: self asApplicationAt: 'ivolunti')
		addLibrary: JQDevelopmentLibrary;
		addLibrary: JQUiDeploymentLibrary;
		preferenceAt: #sessionClass put: VOElectionClientSession;
		preferenceAt: #scriptGeneratorClass put: JQScriptGenerator;
		addLibrary: TWBSDevelopmentLibrary;
		yourself! !

!VOElectionClientComponent methodsFor: 'initialization' stamp: 'NicolasVanderAuwera 11/1/2012 16:27'!
buildMenu
	^ VOMenuComponent new
		addEntry: 'Home' withAction: [ content := VOECElectionsListComponent elections: self session elections ];
		addEntry: 'Accessibility' withAction: [ self setAccessibleView ];
		addEntry: 'About Us' withAction: [ content := VOAboutComponent new ];
		yourself! !

!VOElectionClientComponent methodsFor: 'hooks' stamp: 'NicolasVanderAuwera 11/15/2012 07:32'!
children
	^ super children , (Array with: self content with: configuration)! !

!VOElectionClientComponent methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 10/30/2012 06:44'!
content
	^ content ifNil: [ content := VOECElectionsListComponent elections: self session elections ]! !

!VOElectionClientComponent methodsFor: 'initialization' stamp: 'NicolasVanderAuwera 11/1/2012 16:27'!
initialize
	super initialize.
	configuration := VOECConfigurationTask new! !

!VOElectionClientComponent methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 10/29/2012 08:22'!
renderMainContentOn: html
	self session accessibility
		ifTrue: [ self setAccessibleView ]
		ifFalse: [ 
			VOElectionClient electionManagerConfiguration isConfigured
				ifFalse: [ html render: configuration ]
				ifTrue: [ self renderPageOn: html ] ]! !

!VOElectionClientComponent methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 10/30/2012 15:01'!
renderPageOn: html
	html twbsRow: [ html twbsSpan: 12 with: [ html render: self content ] ]! !

!VOElectionClientComponent methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 11/1/2012 16:41'!
setAccessibleView
	self session accessibility: true.
	self show: VOAccessibilityHomeView new! !

!VOElectionClientComponent methodsFor: 'hooks' stamp: 'NicolasVanderAuwera 5/11/2012 12:00'!
style
	^ 'label, body, td, th {font-size: ' , self session fontSize greaseString , 'px}'! !

!VOElectionClientComponent methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 10/28/2012 11:04'!
title
	^ ''! !

!VOElectionClientComponent methodsFor: 'updating' stamp: 'NicolasVanderAuwera 10/29/2012 16:41'!
updateRoot: anHtmlRoot
	super updateRoot: anHtmlRoot.
	anHtmlRoot title: 'iVolunti'! !

WAFormDialog subclass: #VOChoiceDialog
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-ElectionClient-View'!

!VOChoiceDialog methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 8/2/2012 15:00'!
buttons
	^ #(identify sign)! !

!VOChoiceDialog methodsFor: 'tasks' stamp: 'NicolasVanderAuwera 8/2/2012 15:01'!
identify
	self answer: true! !

!VOChoiceDialog methodsFor: 'tasks' stamp: 'NicolasVanderAuwera 8/2/2012 15:01'!
sign
	self answer: false! !

!VOChoiceDialog methodsFor: 'tasks' stamp: 'NicolasVanderAuwera 1/20/2012 10:17'!
vote
	self answer: false! !

VOUserLoginComponent subclass: #VOMUserLogin
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-ElectionClient-Mobile-View'!

!VOMUserLogin methodsFor: 'actions' stamp: 'NicolasVanderAuwera 2/19/2012 10:22'!
addForm
	form := VOFormDecoration new buttons: self buttons.
	self addDecoration: form! !

WAValidationDecoration subclass: #VOValidationDecoration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-ElectionClient-Mobile-View'!

!VOValidationDecoration methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 2/19/2012 10:01'!
renderContentOn: html
	message contents isNil
		ifFalse: [ 
			html div
				class: 'ui-corner-all ui-state-error';
				with: [ 
							html
								paragraph: [ 
									html span class: 'ui-icon ui-icon-alert'.
									html strong: 'Error: '.
									html text: message contents ] ] ].
	self renderNextOn: html! !

!VOValidationDecoration methodsFor: 'hooks' stamp: 'NicolasVanderAuwera 2/19/2012 10:08'!
style
	^ '.ui-corner-all { padding: 0.1em 0.5em; margin: 1em auto; width: 500px; }
.ui-corner-all .ui-icon { float: left; margin-right: 0.3em; }'! !

WAComponent subclass: #VOAboutComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-ElectionClient-View'!

!VOAboutComponent methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 10/30/2012 09:16'!
authorities
	^ #('Election Manager' 'Homomorphic Authority' 'Public Board' 'Polling Office' 'Certification Authority' 'Mental Booth Authority' 'Registration Office' 'MPDVS Authority')! !

!VOAboutComponent methodsFor: 'initialization' stamp: 'NicolasVanderAuwera 10/30/2012 14:59'!
initialize
	super initialize.
	self recetTips! !

!VOAboutComponent methodsFor: 'actions' stamp: 'NicolasVanderAuwera 10/30/2012 14:59'!
recetTips
	self session announcer announce: (RefreshTips tips: (VOTipsComponent text: ''))! !

!VOAboutComponent methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 10/30/2012 12:44'!
renderAuthoritiesOn: html
	html
		unorderedList: [ 
			self authorities
				do: [ :authority | 
					html
						listItem: [ 
							html anchor
								style: 'cursor:pointer;';
								onClick: ((html jQuery: authority withoutSeparator asSymbol) show: 0.2 seconds);
								with: authority.
							html preformatted
								id: authority withoutSeparator;
								style: 'display:none;';
								with: [ 
											html
												text:
														'Gofer new url: ''http://ss3.gemstone.com/ss/';
												text: authority withoutSeparator;
												text:
														''';
      package: ''ConfigurationOf';
												text: authority withoutSeparator;
												text:
														''';
      load.
(ConfigurationOfVolunti project version: #stable) load.' ] ] ] ]! !

!VOAboutComponent methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 10/30/2012 09:15'!
renderCheckCodeOn: html
	html heading
		level3;
		with: 'Check the code'.
	html
		paragraph: [ 
			html text: 'All the code of '.
			html strong: 'iVolunti'.
			html text: ' is available on two repository: '.
			html anchor
				url: 'http://www.squeaksource.com/Volunti.html';
				with: 'Squeak Source'.
			html text: ' and '.
			html anchor
				url: 'http://ss3.gemstone.com/ss/Volunti.html';
				with: 'Gemstone'.
			html
				text:
					'. You can also import the code in a fresh Pharo image. To do that, download a Pharo image and execute the following code in a workspace:' ].
	html
		preformatted:
			'Gofer it
url: ''http://www.squeaksource.com/Volunti''; "Replace this url with the Gemstone url."
     package: ''ConfigurationOfVolunti'';
     load.
(ConfigurationOfVolunti project version: ''0.3'') load.'.
	html
		paragraph: [ 
			html
				text: 'You can load independently each authority of ';
				strong: 'iVolunti';
				text: ' in a fresh Pharo image. Click on a authority to see the code to execute:' ].
	self renderAuthoritiesOn: html! !

!VOAboutComponent methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 10/28/2012 11:14'!
renderContentOn: html
	self renderTitleOn: html.
	html
		paragraph: [ 
			html strong: 'iVolunti'.
			html
				text:
					' has been developped by Nicolas Vander Auwera for his master thesis in the Departement of Computer Science in the Universit Libre de Bruxelles during 2011-2012.' ].
	self renderReferencesOn: html.
	self renderCheckCodeOn: html.
	self renderVideosOn: html! !

!VOAboutComponent methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 10/28/2012 11:12'!
renderReferencesOn: html
	html heading
		level3;
		with: 'References'.
	html
		paragraph: [ 
			html text: 'To understand how '.
			html strong: 'iVolunti'.
			html text: ' works, you can read some articles about it, available '.
			html anchor
				url: 'http://qualsec.ulb.ac.be/people/jerome-dossogne/';
				with: 'here'.
			html text: '.' ]! !

!VOAboutComponent methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 2/15/2012 09:57'!
renderTitleOn: html
	html heading
		level: 2;
		with: self title! !

!VOAboutComponent methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 10/28/2012 11:08'!
renderVideosOn: html
	html heading
		level3;
		with: 'Videos'! !

!VOAboutComponent methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 2/13/2012 11:08'!
title
	^ 'About Us'! !

WAComponent subclass: #VOAccessibilityConfigurationView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-ElectionClient-Accessibility-View'!

!VOAccessibilityConfigurationView methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 2/20/2012 09:25'!
colors
	^ #(black red lime blue yellow aqua fuchsia silver olive)! !

!VOAccessibilityConfigurationView methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 8/24/2012 08:34'!
css
	| stream |
	stream := WriteStream on: String new.
	self colors
		do: [ :color | 
			stream
				nextPutAll: '#li-';
				nextPutAll: color;
				nextPutAll: '{background-color:';
				nextPutAll: color;
				nextPutAll: ';} #text-';
				nextPutAll: color;
				nextPutAll: '{color:';
				nextPutAll: color;
				nextPutAll: ';}' ].
	^ stream contents! !

!VOAccessibilityConfigurationView methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 2/24/2012 10:53'!
renderBackgroundColorOn: html
	html div
		class: 'offset-by-one ten';
		with: [ 
					html heading
						level2;
						with: 'Background color'.
					html
						unorderedList: [ 
							self colors
								do: [ :color | 
									html listItem
										id: 'li-' , color;
										class: 'square';
										onClick: ((html jQuery: 'body') cssAt: 'background-color' put: color);
										onClick: (html jQuery ajax callback: [ :value | self session backColor: value ] value: color) ] ] ]! !

!VOAccessibilityConfigurationView methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 2/20/2012 08:33'!
renderContentOn: html
	self renderBackgroundColorOn: html.
	self renderTextColorOn: html! !

!VOAccessibilityConfigurationView methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 2/24/2012 10:53'!
renderTextColorOn: html
	html div
		class: 'ten offset-by-one';
		with: [ 
					html heading
						level2;
						with: 'Text color'.
					html
						unorderedList: [ 
							self colors
								do: [ :color | 
									html listItem
										id: 'text-' , color;
										class: 'square';
										onClick: ((html jQuery: 'body') cssAt: 'color' put: color , ' !!important');
										onClick: ((html jQuery: '.container, .square') cssAt: 'border-color' put: color);
										onClick: (html jQuery ajax callback: [ :value | self session textColor: value ] value: color);
										with: 'A' ] ] ]! !

!VOAccessibilityConfigurationView methodsFor: 'hooks' stamp: 'NicolasVanderAuwera 2/24/2012 10:56'!
style
	^ '.square {display: inline-block; width: 80px; height: 80px; line-height: 200%; text-align: center; margin-left: 10px; cursor: pointer;} ' , self css! !

WAComponent subclass: #VOAccessibilityHomeView
	instanceVariableNames: 'content list'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-ElectionClient-Accessibility-View'!

!VOAccessibilityHomeView methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 10/30/2012 15:03'!
backToOriginalVersion
	self session accessibility: false.
	self show: VOElectionClientComponent new! !

!VOAccessibilityHomeView methodsFor: 'hooks' stamp: 'NicolasVanderAuwera 8/28/2012 09:07'!
children
	^ Array with: content with: list! !

!VOAccessibilityHomeView methodsFor: 'initialization' stamp: 'NicolasVanderAuwera 10/30/2012 06:44'!
initialize
	super initialize.
	content := VOAccessibilityConfigurationView new.
	list := VOECElectionsListComponent elections: self session elections! !

!VOAccessibilityHomeView methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 2/21/2012 14:48'!
renderBackToOriginalVersionOn: html
	html anchor
		callback: [ self backToOriginalVersion ];
		with: 'Back to original version'! !

!VOAccessibilityHomeView methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 8/28/2012 09:10'!
renderContentOn: html
	html div
		class: 'container';
		style: 'text-align:center;';
		with: [ 
					html heading
						level1;
						with: self title.
					html horizontalRule.
					html render: content.
					html horizontalRule.
					html render: list.
					html horizontalRule.
					self renderBackToOriginalVersionOn: html ]! !

!VOAccessibilityHomeView methodsFor: 'hooks' stamp: 'NicolasVanderAuwera 8/28/2012 09:09'!
style
	^ ' body {font-size: 20px; background-color:' , self session backColor , ';  color: ' , self session textColor
		, ';} a {color: ' , self session textColor , ';}' , '.container, li {border: solid 1px ' , self session textColor
		, ';} table {margin:auto;}'! !

!VOAccessibilityHomeView methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 8/28/2012 09:10'!
title
	^ 'iVolunti'! !

!VOAccessibilityHomeView methodsFor: 'updating' stamp: 'NicolasVanderAuwera 2/20/2012 10:15'!
updateRoot: aHtmlRoot
	super updateRoot: aHtmlRoot.
	"aHtmlRoot stylesheet url: (VOFileLibrary urlOf: #baseCss)."
	aHtmlRoot stylesheet url: (VOFileLibrary urlOf: #layoutCss).
	aHtmlRoot stylesheet url: (VOFileLibrary urlOf: #skeletonCss)! !

WAComponent subclass: #VOChooseBallotView
	instanceVariableNames: 'ballots choices'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-ElectionClient-View'!

VOChooseBallotView subclass: #VOChooseAlternativeBallotView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-ElectionClient-View'!

!VOChooseAlternativeBallotView methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 8/4/2012 09:02'!
renderBallot: ballot index: i on: html
	html div
		class: 'ballot';
		with: [ 
					self renderBallot: ballot on: html.
					self renderChoose: i on: html ]! !

!VOChooseAlternativeBallotView methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 8/24/2012 16:34'!
renderBallot: ballot on: html
	html
		table: [ 
			self renderHeadingOn: html.
			html div
				class: 'secrets ui-corner-all';
				with: [ 
							ballot votes
								with: choices
								do: [ :vote :choice | 
									html
										tableRow: [ 
											html tableData: choice name.
											html tableData: [ html image url: vote ] ] ] ] ]! !

!VOChooseAlternativeBallotView methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 8/4/2012 14:29'!
renderBallotsOn: html
	self ballots
		keysAndValuesDo: [ :i :ballot | 
			html paragraph: 'Ballot ' , i greaseString.
			self renderBallot: ballot index: i on: html ]! !

!VOChooseBallotView class methodsFor: 'instance creation' stamp: 'NicolasVanderAuwera 8/23/2012 14:03'!
ballots: aCollection choices: anotherCollection
	^ self new
		ballots: aCollection;
		choices: anotherCollection;
		yourself! !

!VOChooseBallotView methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 8/23/2012 14:00'!
ballots
	^ ballots! !

!VOChooseBallotView methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 8/23/2012 14:01'!
ballots: anObject
	ballots := anObject! !

!VOChooseBallotView methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 8/23/2012 14:01'!
choices
	^ choices! !

!VOChooseBallotView methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 8/23/2012 14:00'!
choices: anObject
	choices := anObject! !

!VOChooseBallotView methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 8/23/2012 14:00'!
heading
	^ #('Candidate' 'Vote')! !

!VOChooseBallotView methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 5/9/2012 09:57'!
renderBallot: ballot index: i on: html
	html div
		class: 'ballot';
		with: [ 
					self renderBallot: ballot on: html.
					self renderChoose: i on: html ]! !

!VOChooseBallotView methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 8/23/2012 14:00'!
renderBallot: ballot on: html
	html
		table: [ 
			self renderHeadingOn: html.
			ballot votes
				with: choices
				do: [ :vote :choice | 
					html
						tableRow: [ 
							html tableData: choice name.
							html tableData: vote ] ] ]! !

!VOChooseBallotView methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 8/23/2012 14:00'!
renderBallotsOn: html
	self ballots do: [ :ballot | self renderBallot: ballot on: html ]! !

!VOChooseBallotView methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 5/7/2012 12:54'!
renderChoose: i on: html
	html
		form: [ 
			html submitButton
				callback: [ self answer: i ];
				with: 'Choose' ]! !

!VOChooseBallotView methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 8/23/2012 14:01'!
renderContentOn: html
	self renderTitleOn: html.
	self renderBallotsOn: html! !

!VOChooseBallotView methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 8/23/2012 14:00'!
renderHeadingOn: html
	html tableRow: [ self heading do: [ :head | html tableHeading: head ] ]! !

!VOChooseBallotView methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 8/23/2012 14:00'!
renderTitleOn: html
	html heading
		level2;
		with: self title! !

!VOChooseBallotView methodsFor: 'hooks' stamp: 'NicolasVanderAuwera 8/23/2012 14:00'!
style
	^ '.green-highlight {background-color: #abf791;}'! !

!VOChooseBallotView methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 8/23/2012 14:00'!
title
	^ 'Verification'! !

WAComponent subclass: #VODigipassSignaturesView
	instanceVariableNames: 'signatures'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-ElectionClient-View'!

!VODigipassSignaturesView class methodsFor: 'instance creation' stamp: 'NicolasVanderAuwera 8/26/2012 09:17'!
signatures: aList
	^ self new signatures: aList! !

!VODigipassSignaturesView methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 8/26/2012 09:19'!
renderContentOn: html
	html paragraph: 'Anonymous signatures on each votes:'.
	signatures
		do: [ :signature | 
			html textArea
				disabled: true;
				value: signature greaseString ].
	html anchor
		class: 'button';
		callback: [ self answer ];
		with: 'OK'! !

!VODigipassSignaturesView methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 8/26/2012 09:17'!
signatures: aList
	signatures := aList! !

WAComponent subclass: #VOFieldsInputView
	instanceVariableNames: 'numberOfFields signatures'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-ElectionClient-View'!

!VOFieldsInputView class methodsFor: 'instance creation' stamp: 'NicolasVanderAuwera 8/26/2012 09:13'!
numberOfFields: aNumber
	^ self new numberOfFields: aNumber! !

!VOFieldsInputView methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 8/26/2012 09:13'!
numberOfFields: aNumber
	numberOfFields := aNumber! !

!VOFieldsInputView methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 8/26/2012 09:45'!
renderContentOn: html
	html paragraph: 'Please copy encrypted votes in each field.'.
	html
		form: [ 
			1 to: numberOfFields do: [ :i | html textInput callback: [ :value | self signatures at: i put: value greaseInteger ] ].
			html submitButton callback: [ self answer: self signatures ] ]! !

!VOFieldsInputView methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 8/26/2012 09:14'!
signatures
	^ signatures ifNil: [ signatures := Array new: numberOfFields ]! !

WAComponent subclass: #VOInformDialog
	instanceVariableNames: 'body title'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-ElectionClient-View'!

!VOInformDialog class methodsFor: 'instance creation' stamp: 'NicolasVanderAuwera 2/19/2012 14:32'!
title: aString body: anotherString
	^ self new
		title: aString;
		body: anotherString;
		yourself! !

!VOInformDialog methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 2/7/2012 07:51'!
body
	^ body! !

!VOInformDialog methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 2/7/2012 07:51'!
body: anObject
	body := anObject! !

!VOInformDialog methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 5/5/2012 16:55'!
renderBodyOn: html
	html textArea
		class: 'span-6';
		value: self body greaseString! !

!VOInformDialog methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 2/19/2012 14:33'!
renderContentOn: html
	self renderTitleOn: html.
	self renderBodyOn: html.
	self renderSubmitButtonOn: html! !

!VOInformDialog methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 2/19/2012 14:32'!
renderSubmitButtonOn: html
	html
		form: [ 
			html submitButton
				callback: [ self answer ];
				with: 'Ok' ]! !

!VOInformDialog methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 2/19/2012 14:33'!
renderTitleOn: html
	html heading
		level4;
		with: self title! !

!VOInformDialog methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 2/7/2012 07:51'!
title
	^ title! !

!VOInformDialog methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 2/7/2012 07:51'!
title: anObject
	title := anObject! !

WAComponent subclass: #VOMElectionView
	instanceVariableNames: 'elections'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-ElectionClient-Mobile-View'!

!VOMElectionView class methodsFor: 'instance creation' stamp: 'NicolasVanderAuwera 2/18/2012 15:37'!
elections: electionsList
	^ self new elections: electionsList! !

!VOMElectionView methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 2/18/2012 15:36'!
elections
	^ elections! !

!VOMElectionView methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 2/18/2012 15:36'!
elections: anObject
	elections := anObject! !

!VOMElectionView methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 2/19/2012 10:23'!
renderAnchorForElection: election On: html
	html anchor
		jqmButton;
		jqmIcon: 'arrow-r';
		jqmTheme: 'b';
		class: 'ui-btn-right';
		callback: [ self call: (VOMVoteProcessTask new election: election) ];
		with: 'Participate'! !

!VOMElectionView methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 5/17/2012 07:22'!
renderContentOn: html
	self renderTitleOn: html.
	html
		table: [ 
			self elections
				do: [ :election | 
					html
						tableRow: [ 
							html tableData: [ html strong: election name ].
							html tableData: [ self renderAnchorForElection: election On: html ] ] ] ]! !

!VOMElectionView methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 2/18/2012 15:48'!
renderTitleOn: html
	html heading
		level1;
		with: self title! !

!VOMElectionView methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 2/18/2012 15:48'!
title
	^ 'Elections'! !

WAComponent subclass: #VOMGeneralView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-ElectionClient-Mobile-View'!

!VOMGeneralView methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 2/19/2012 09:29'!
renderAnchorHomeOn: html
	html anchor
		jqmIcon: 'home';
		callback: [ self show: VOMHomePage new ];
		with: 'Home'! !

!VOMGeneralView methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 2/19/2012 09:19'!
renderAnchorOptionOn: html
	html anchor
		jqmIcon: 'gear';
		callback: [ self call: VOMOptionPage new ];
		with: 'Option'! !

!VOMGeneralView methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 2/19/2012 09:35'!
renderContentOn: html
	self renderHeaderOn: html.
	self renderMainOn: html.
	"self renderFooterOn: html"! !

!VOMGeneralView methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 2/18/2012 16:07'!
renderFooterOn: html
	html div
		jqmFooter;
		jqmFixedPosition;
		class: 'footer-docs';
		with: [ 
					html heading
						level1;
						with: 'Fixed Footer' ]! !

!VOMGeneralView methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 2/18/2012 13:08'!
renderHeaderOn: html
	html div
		jqmHeader;
		jqmTheme: #a;
		with: [ 
					self renderAnchorHomeOn: html.
					self renderTitleOn: html.
					self renderAnchorOptionOn: html ]! !

!VOMGeneralView methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 2/18/2012 13:11'!
renderMainContentOn: html! !

!VOMGeneralView methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 2/19/2012 09:39'!
renderMainOn: html
	html div
		jqmContent;
		jqmTheme: self session theme;
		with: [ self renderMainContentOn: html ]! !

!VOMGeneralView methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 2/18/2012 13:18'!
renderTitleOn: html
	html heading
		level1;
		with: self title! !

!VOMGeneralView methodsFor: 'hooks' stamp: 'NicolasVanderAuwera 2/18/2012 16:11'!
style
	^ 'html {
	height: 100%;
}
body {
	margin: 0;
	padding: 0;
	height: 100%;
}
.landscape, .landscape .ui-page, .portrait, .portrait .ui-page {
	min-height: 100%;
}'! !

!VOMGeneralView methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 2/18/2012 13:18'!
title
	^ 'Volunti'! !

!VOMGeneralView methodsFor: 'updating' stamp: 'NicolasVanderAuwera 2/21/2012 14:42'!
updateRoot: anHtmlRoot
	super updateRoot: anHtmlRoot.
	anHtmlRoot title: 'Volunti Mobile' translated.
	anHtmlRoot stylesheet url: (VOFileLibrary urlOf: #appmobileCss)! !

VOMGeneralView subclass: #VOMHomePage
	instanceVariableNames: 'content'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-ElectionClient-Mobile-View'!

!VOMHomePage class methodsFor: 'initialization' stamp: 'NicolasVanderAuwera 2/19/2012 10:25'!
initialize
	(JQMAdmin register: self asApplicationAt: 'volunti-mobile')
		preferenceAt: #sessionClass put: VOElectionClientSession! !

!VOMHomePage methodsFor: 'hooks' stamp: 'NicolasVanderAuwera 2/18/2012 13:12'!
children
	^ Array with: content! !

!VOMHomePage methodsFor: 'initialization' stamp: 'NicolasVanderAuwera 2/18/2012 13:12'!
initialize 
	super initialize.
	content := VOMElectionView elections: self session elections! !

!VOMHomePage methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 2/18/2012 13:12'!
renderMainContentOn: html
	html render: content! !

VOMGeneralView subclass: #VOMOptionPage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-ElectionClient-Mobile-View'!

!VOMOptionPage methodsFor: 'defaults' stamp: 'NicolasVanderAuwera 2/18/2012 12:44'!
defaultTheme 
	^ #c! !

!VOMOptionPage methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 2/19/2012 09:29'!
renderCancelAnchorOn: html
	html anchor
		jqmIcon: 'delete';
		jqmInline;
		jqmButton;
		callback: [ self answer ];
		with: 'Cancel'! !

!VOMOptionPage methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 3/5/2012 14:38'!
renderFontSizeModifierOn: html
	html
		div: [ 
			html label
				for: html lastId;
				with: 'Font Size'.
			html rangeInput
				id: html lastId;
				callback: [ :value | self session fontSize: value greaseInteger ];
				value: self session fontSize;
				min: 9;
				max: 20 ]! !

!VOMOptionPage methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 2/18/2012 13:47'!
renderMainContentOn: html
	html div
		jqmFieldContainer;
		with: [ 
					html form
						jqmTransitionFade;
						with: [ 
									self renderThemeSwitcherOn: html.
									self renderFontSizeModifierOn: html.
									self renderCancelAnchorOn: html.
									self renderSaveButtonOn: html ] ]! !

!VOMOptionPage methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 2/18/2012 14:19'!
renderSaveButtonOn: html
	html submitButton
		jqmIcon: 'check';
		jqmInline;
		jqmTheme: 'b';
		callback: [ self show: VOMHomePage new ];
		with: 'Save'! !

!VOMOptionPage methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 2/18/2012 13:25'!
renderThemeSwitcherOn: html
	html label
		for: html nextId;
		with: 'Theme: '.
	html select
		jqmDisableNativeMenu;
		id: html lastId;
		list: self themes;
		selected: self session theme;
		callback: [ :value | self session theme: value ]! !

!VOMOptionPage methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 2/18/2012 12:44'!
themes
	^ #(a b c d e)
	! !

WAComponent subclass: #VOShowCommitments
	instanceVariableNames: 'ballotsToCheck'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-ElectionClient-View'!

!VOShowCommitments class methodsFor: 'instance creation' stamp: 'NicolasVanderAuwera 8/4/2012 14:16'!
ballotsToCheck: list
^ self new ballotsToCheck: list! !

!VOShowCommitments methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 8/4/2012 14:17'!
ballotsToCheck: list
	ballotsToCheck := list! !

!VOShowCommitments methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 8/23/2012 13:58'!
contents
	| xml |
	xml := XMLWriter on: (WriteStream on: String new).
	xml xmlDeclaration: '1.0' encoding: 'UTF-8'.
	xml
		startTag: 'ballots';
		endTag. 
	ballotsToCheck do: [ :ballot | xml stream nextPutAll: ballot asXML ].
	xml
		startTag: '/ballots';
		endTag.
	^ xml stream contents! !

!VOShowCommitments methodsFor: 'task' stamp: 'NicolasVanderAuwera 8/23/2012 13:56'!
createFile
	^ WAFile new
		contentType: WAMimeType textPlain;
		contents: self contents;
		fileName: 'commitments'! !

!VOShowCommitments methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 8/20/2012 08:22'!
downloadFile
	| file |
	file := self createFile.
	self requestContext
		respond: [ :response | 
			response
				contentType: 'text/xml';
				document: file rawContents greaseString;
				attachmentWithFileName: file fileName ]! !

!VOShowCommitments methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 8/23/2012 14:37'!
renderContentOn: html
	html paragraph
		class: 'info';
		with: 'The Polling Office commits all votes, wich are not submit. You can now download them.'.
	html paragraph
		class: 'warning';
		with: [ 
					html text: 'You can download proofs with this '.
					html anchor
						callback: [ self downloadFile ];
						with: 'link'.
					html text: '.' ].
	html anchor
		class: 'button';
		callback: [ self answer ];
		with: 'Continue'! !

WAComponent subclass: #VOShowEncryptedVotes
	instanceVariableNames: 'ballots encryptedVotes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-ElectionClient-View'!

!VOShowEncryptedVotes class methodsFor: 'instance creation' stamp: 'NicolasVanderAuwera 8/4/2012 13:22'!
ballots: ballots encryptedVotes: votes
	^ self new
		ballots: ballots;
		encryptedVotes: votes;
		yourself! !

!VOShowEncryptedVotes methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 8/4/2012 13:22'!
ballots: list
	ballots := list! !

!VOShowEncryptedVotes methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 8/18/2012 07:56'!
contents
	| stream |
	stream := WriteStream on: String new.
	encryptedVotes
		keysAndValuesDo: [ :index :array | 
			stream
				nextPutAll: 'Ballot ';
				nextPutAll: index greaseString;
				nextPut: Character cr.
			array
				do: [ :vote | 
					stream
						nextPutAll: vote greaseString;
						nextPut: Character cr ].
			stream
				nextPut: Character cr;
				nextPut: Character cr ].
	^ stream contents! !

!VOShowEncryptedVotes methodsFor: 'task' stamp: 'NicolasVanderAuwera 8/23/2012 13:56'!
createFile
	^ WAFile new
		contentType: WAMimeType textPlain;
		contents: self contents;
		fileName: 'encrypted_votes'! !

!VOShowEncryptedVotes methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 8/18/2012 07:56'!
downloadFile
	| file |
	file := self createFile.
	self requestContext
		respond: [ :response | 
			response
				contentType: 'text/xml';
				document: file rawContents greaseString;
				attachmentWithFileName: file fileName ]! !

!VOShowEncryptedVotes methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 8/4/2012 13:22'!
encryptedVotes: list
	encryptedVotes := list! !

!VOShowEncryptedVotes methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 8/6/2012 14:07'!
renderContentOn: html
	html paragraph
		class: 'info';
		with: 'The Polling Office encrypted your votes. You can now download them.'.
	html paragraph
		class: 'warning';
		with: [ 
					html text: 'You can download proofs with this '.
					html anchor
						callback: [ self downloadFile ];
						with: 'link'.
					html text: '.' ].
	html anchor
		class: 'button';
		callback: [ self answer ];
		with: 'Continue'! !

WAComponent subclass: #VOTipsComponent
	instanceVariableNames: 'text'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-ElectionClient-View'!

!VOTipsComponent class methodsFor: 'instance creation' stamp: 'NicolasVanderAuwera 10/28/2012 11:21'!
text: aString
	^ self new text: aString! !

!VOTipsComponent methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 10/30/2012 14:30'!
renderContentOn: html
	(text isNil or: [ text isEmpty ])
		ifFalse: [ 
			html paragraph
				class: 'alert alert-info';
				with: [ 
							html strong: self title.
							html break.
							html text: text ] ]! !

!VOTipsComponent methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 10/28/2012 11:22'!
text: aString
	text := aString! !

!VOTipsComponent methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 10/28/2012 11:22'!
title
	^ 'Tips'! !

WAFormDecoration subclass: #VOFormDecoration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-ElectionClient-Mobile-View'!

!VOFormDecoration methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 2/19/2012 13:56'!
renderButtonForSelector: aSymbol on: html
	html submitButton
		jqmInline;
		jqmTheme: 'b';
		on: aSymbol of: self decoratedComponent! !

VOFormView subclass: #VOPinCodeFormView
	instanceVariableNames: 'pin'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-ElectionClient-View'!

!VOPinCodeFormView methodsFor: 'searching' stamp: 'NicolasVanderAuwera 11/20/2012 09:29'!
findDigipass
	^ VODigipass withPin: pin greaseInteger! !

!VOPinCodeFormView methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 1/4/2012 08:03'!
renderContentOn: html
	html heading
		level: 4;
		with: 'Enter your pin code'.
	super renderContentOn: html! !

!VOPinCodeFormView methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 12/29/2011 09:26'!
renderFormContentOn: html
	self renderPasswordInputOn: html! !

!VOPinCodeFormView methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 12/29/2011 09:25'!
renderPasswordInputOn: html
	| id |
	html label
		for: (id := html nextId);
		with: 'Pin Code'.
	html passwordInput
		id: id;
		callback: [ :value | pin := value ]! !

!VOPinCodeFormView methodsFor: 'actions' stamp: 'NicolasVanderAuwera 1/23/2012 14:57'!
submit
	self answer: self findDigipass! !

TestCase subclass: #VOElectionClientTest
	instanceVariableNames: 'electionClient'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-ElectionClient-Tests'!

!VOElectionClientTest methodsFor: 'running' stamp: 'NicolasVanderAuwera 1/4/2012 07:43'!
setUp
	electionClient := VOElectionClient new! !

WADecoration subclass: #VODescriptionView
	instanceVariableNames: 'text'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-ElectionClient-View'!

!VODescriptionView class methodsFor: 'instance creation' stamp: 'NicolasVanderAuwera 7/30/2012 13:42'!
text: aString
	^ self new text: aString! !

!VODescriptionView methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 7/30/2012 13:54'!
renderNextOn: html
	(html div)
		class: 'info';
		with: text.
	super renderNextOn: html! !

!VODescriptionView methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 7/30/2012 13:42'!
text: aString
	text := aString! !

VOBallotView subclass: #VOMBallotView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-ElectionClient-Mobile-View'!

!VOMBallotView methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 5/17/2012 05:40'!
renderNamesAndVotesOn: html
	html
		table: [ 
			choices
				with: self model votes
				do: [ :choice :vote | 
					html
						tableRow: [ 
							html tableData: choice name.
							html tableData: vote ] ] ]! !

VOBallotEditor subclass: #VOMBallotEditor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-ElectionClient-Mobile-View'!

!VOMBallotEditor methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 8/25/2012 11:06'!
renderVotesOn: html
	html fieldSet
		jqmControlGroup;
		with: [ 
					html radioGroup
						with: [ :aGroup | 
							choices
								doWithIndex: [ :choice :i | 
									html label
										for: html nextId;
										with: choice name.
									html radioButton
										group: aGroup;
										callback: [ self model give: 1 additionalPointsTo: i ];
										id: html lastId ] ] ]! !

VOPage subclass: #VOECAuthenticationPage
	instanceVariableNames: 'digipass zkauthentication setup'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-ElectionClient-View'!

!VOECAuthenticationPage methodsFor: 'hooks' stamp: 'NicolasVanderAuwera 8/24/2012 08:41'!
children
	^ Array with: digipass with: setup! !

!VOECAuthenticationPage methodsFor: 'initialization' stamp: 'NicolasVanderAuwera 8/24/2012 08:28'!
initialize
	super initialize.
	digipass := VODigipassTask new.
	setup := VOECSetupTask new! !

!VOECAuthenticationPage methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 8/28/2012 09:04'!
renderAsideOn: html
	html div
		class: 'aside-block';
		with: [ 
					html image url: (VOFileLibrary urlOf: #digipassPng).
					html heading
						class: 'inline';
						level2;
						with: 'Digipass'.
					html render: digipass ]! !

!VOECAuthenticationPage methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 8/24/2012 08:41'!
renderMainContentOn: html
	html render: setup! !

VOPage subclass: #VOECSetupPage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-ElectionClient-View'!

!VOECSetupPage methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 8/24/2012 09:16'!
elements
	^ #(#registration #anonymisation #secret)! !

!VOECSetupPage methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 8/24/2012 09:15'!
renderAnonymisationOn: html
	html
		div: [ 
			html heading
				level4;
				with: '2. Become anonymous'.
			html paragraph: 'Contact the anonymous authority to become anonymous for the election.'.
			html anchor
				class: 'button';
				callback: [ self call: VOECAuthenticationPage new ];
				with: 'Become anonymous' ]! !

!VOECSetupPage methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 5/5/2012 08:35'!
renderBackAnchorOn: html
	html anchor
		callback: [ self answer ];
		with: 'Back to home'! !

!VOECSetupPage methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 8/24/2012 09:20'!
renderElementsOn: html
	self elements
		do: [ :element | self perform: ('render' , element capitalized , 'On:') asSymbol with: html ]
		separatedBy: [ html horizontalRule ]! !

!VOECSetupPage methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 8/24/2012 09:18'!
renderMainContentOn: html
	self renderTitleOn: html.
	self renderElementsOn: html.
	self renderBackAnchorOn: html! !

!VOECSetupPage methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 8/24/2012 09:15'!
renderRegistrationOn: html
	html heading
		level4;
		with: '1. Registration'.
	html
		paragraph: [ 
			html text: 'Go to the '.
			html anchor
				url: 'http://localhost:8080/registrationoffice';
				with: 'Registration Office'.
			html text: ' to get your digipass.' ]! !

!VOECSetupPage methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 8/24/2012 09:15'!
renderSecretOn: html
	html heading
		level4;
		with: '3. Get your secret'.
	html
		paragraph: [ 
			html text: 'Present yourself personally to the '.
			html anchor
				url: 'http://localhost:8080/mentalboothauth';
				with: 'Mental Booth Office'.
			html text: '.' ]! !

!VOECSetupPage methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 5/5/2012 08:19'!
renderTitleOn: html
	html heading
		level2;
		with: self title! !

!VOECSetupPage methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 5/5/2012 08:33'!
title
	^ 'Setup'! !

VOPage subclass: #VOSignaturesPage
	instanceVariableNames: 'model digipass signatures'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-ElectionClient-View'!

!VOSignaturesPage class methodsFor: 'instance creation' stamp: 'NicolasVanderAuwera 8/23/2012 14:36'!
model: signatures
	^ self new model: signatures! !

!VOSignaturesPage methodsFor: 'hooks' stamp: 'NicolasVanderAuwera 8/25/2012 07:32'!
children
	^ Array with: digipass! !

!VOSignaturesPage methodsFor: 'initialization' stamp: 'NicolasVanderAuwera 8/25/2012 07:17'!
initialize
	super initialize.
	digipass := VODigipassTask new! !

!VOSignaturesPage methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 8/23/2012 14:36'!
model: aList
	model := aList! !

!VOSignaturesPage methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 8/25/2012 07:18'!
renderAsideOn: html
	html image url: (VOFileLibrary urlOf: #digipassPng).
	html heading
		class: 'inline';
		level2;
		with: 'Digipass'.
	html render: digipass! !

!VOSignaturesPage methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 8/25/2012 07:19'!
renderInformationOn: html
	html paragraph
		class: 'info';
		with: 'Please sign anonymously each vote'! !

!VOSignaturesPage methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 8/25/2012 07:41'!
renderMainContentOn: html
	self renderTitleOn: html.
	self renderInformationOn: html.
	html
		form: [ 
			model
				keysAndValuesDo: [ :index :vote | 
					html paragraph: vote greaseString.
					html label
						for: html nextId;
						with: 'Signature'.
					html textInput
						id: html lastId;
						callback: [ :value | self signatures at: index put: value greaseInteger ] ].
			html submitButton
				callback: [ self answer: self signatures ];
				with: 'Continue' ]! !

!VOSignaturesPage methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 8/23/2012 14:39'!
renderTitleOn: html
	html heading
		level2;
		with: self title! !

!VOSignaturesPage methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 8/25/2012 07:41'!
signatures
	^ signatures ifNil: [ signatures := Array new: model size ]! !

!VOSignaturesPage methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 8/23/2012 14:39'!
title
	^ 'Sign your ballot'! !

Object subclass: #VOECProtocol
	instanceVariableNames: 'election user configurations id identificationUser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-ElectionClient-Model'!

VOECProtocol subclass: #VOECAnonymousProtocol
	instanceVariableNames: 'anonymousCert registrationUser client'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-ElectionClient-Model'!

!VOECAnonymousProtocol methodsFor: 'network' stamp: 'NicolasVanderAuwera 7/23/2012 07:39'!
authenticate
	"connects to the AA and receives the signed id"

	| anonymousAuth challenge |
	anonymousAuth := self configurations at: VOAnonymousManager key.
	client := SocketStream openConnectionToHostNamed: anonymousAuth host port: anonymousAuth port.
	client
		sendCommand: #authenticate;
		sendCommand: id greaseString;
		sendObject: self registrationUser.
	client nextLine asSymbol = #success
		ifTrue: [ challenge := client nextLine greaseInteger ].
	client close.
	^ challenge! !

!VOECAnonymousProtocol methodsFor: 'network' stamp: 'NicolasVanderAuwera 8/2/2012 15:17'!
authenticate: aUser
	"connects to the AA and receives the signed id"

	| anonymousAuth challenge |
	user := aUser.
	anonymousAuth := self configurations at: VOAnonymousManager key.
	client := SocketStream openConnectionToHostNamed: anonymousAuth host port: anonymousAuth port.
	client
		sendCommand: #authenticate;
		sendCommand: id greaseString;
		sendObject: aUser.
	client nextLine asSymbol = #success
		ifTrue: [ challenge := client nextLine greaseInteger ].
	client close.
	^ challenge! !

!VOECAnonymousProtocol methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 5/5/2012 15:54'!
getIdentifier
	! !

!VOECAnonymousProtocol methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 5/8/2012 13:29'!
identificationUserClass
	^ VOMBUser ! !

!VOECAnonymousProtocol methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 5/8/2012 10:15'!
registrationUser
	registrationUser isNil
		ifTrue: [ registrationUser := self registrationUserClass new ].
	^ registrationUser! !

!VOECAnonymousProtocol methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 5/11/2012 07:44'!
registrationUserClass
	^ VOAdvancedUser! !

!VOECAnonymousProtocol methodsFor: 'network' stamp: 'NicolasVanderAuwera 7/23/2012 07:39'!
sendBlindedId: anInteger
	| signature anonymousAuth |
	anonymousAuth := self configurations at: VOAnonymousManager key.
	client := SocketStream openConnectionToHostNamed: anonymousAuth host port: anonymousAuth port.
	client
		sendCommand: #blindedid;
		sendCommand: id greaseString;
		sendCommand: anInteger greaseString.
	signature := client nextLine greaseInteger.
	client close.
	^ signature! !

!VOECAnonymousProtocol methodsFor: 'network' stamp: 'NicolasVanderAuwera 8/20/2012 07:17'!
sendResponse: anInteger
	| anonymousAuth ok |
	ok := true.
	anonymousAuth := self configurations at: VOAnonymousManager key.
	client := SocketStream openConnectionToHostNamed: anonymousAuth host port: anonymousAuth port.
	client
		sendCommand: #response;
		sendCommand: id greaseString;
		sendObject: user.
	client sendCommand: anInteger greaseString.
	client nextLine greaseString = 'error'
		ifTrue: [ ok := false ].
	client close.
	^ ok! !

!VOECAnonymousProtocol methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 3/29/2012 12:57'!
userClass
	^ VOAnonymousUser! !

VOECAnonymousProtocol subclass: #VOECMBProtocol
	instanceVariableNames: 'ballots anonymousCertificate encryptedVotes paillierPk position thresholdPublicKey ballotsToCheck'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-ElectionClient-Model'!

VOECMBProtocol subclass: #VOECAlternativeMBProtocol
	instanceVariableNames: 'availableSecrets'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-ElectionClient-Model'!

!VOECAlternativeMBProtocol methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 5/8/2012 14:01'!
availableSecrets
	availableSecrets ifNil: [ self requestAvailableSecrets ].
	^ availableSecrets! !

!VOECAlternativeMBProtocol methodsFor: 'network' stamp: 'NicolasVanderAuwera 7/23/2012 07:40'!
requestAvailableSecrets
	| stream mentalBoothAuth |
	mentalBoothAuth := self configurations at: VOMentalBoothManager key.
	stream := SocketStream openConnectionToHostNamed: mentalBoothAuth host port: mentalBoothAuth port.
	stream
		sendCommand: #secrets;
		sendCommand: id greaseString;
		sendCommand: identificationUser id greaseString.
	availableSecrets := stream receiveObject.
	stream close! !

!VOECMBProtocol methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 5/7/2012 07:53'!
anonymousCertificate
	anonymousCertificate ifNil: [ self requestAnonymousCertificate ].
	^ anonymousCertificate! !

!VOECMBProtocol methodsFor: 'tasks' stamp: 'NicolasVanderAuwera 8/23/2012 13:29'!
auditBallotsOf: voter
	| config |
	config := self configurations at: VOPollingOfficeManager key.
	client := SocketStream openConnectionToHostNamed: config host port: config port.
	client
		sendCommand: #audit;
		sendCommand: id greaseString;
		sendCommand: position greaseString;
		sendCommand: voter id greaseString.
	ballotsToCheck := client receiveObject.
	^ self checkBallots: ballotsToCheck! !

!VOECMBProtocol methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 2/21/2012 16:56'!
ballots
	ballots ifNil: [ self initializeBallots ].
	^ ballots! !

!VOECMBProtocol methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 8/4/2012 13:35'!
ballotsToCheck
	^ ballotsToCheck! !

!VOECMBProtocol methodsFor: 'tasks' stamp: 'NicolasVanderAuwera 7/23/2012 07:39'!
cast: collection
	| config client |
	config := self configurations at: VOPollingOfficeManager key.
	client := SocketStream openConnectionToHostNamed: config host port: config port.
	client noTimeout.
	client
		sendCommand: #vote;
		sendCommand: id greaseString;
		sendObject: collection.
	encryptedVotes := client receiveObject.
	client close! !

!VOECMBProtocol methodsFor: 'tasks' stamp: 'NicolasVanderAuwera 7/23/2012 07:39'!
castBallot: aBallot
	| config client |
	aBallot votes: (encryptedVotes at: position).
	config := self configurations at: VOPollingOfficeManager key.
	client := SocketStream openConnectionToHostNamed: config host port: config port.
	client
		sendCommand: #cast;
		sendCommand: id greaseString;
		sendObject: aBallot.
	client nextLine = 'success'
		ifFalse: [ self error: 'An error occured during the process.' ]! !

!VOECMBProtocol methodsFor: 'tasks' stamp: 'NicolasVanderAuwera 8/23/2012 14:05'!
checkBallots: collection
	| encryptedBallot share encryptedVote correct |
	correct := true.
	collection
		keysAndValuesDo: [ :i :vc | 
			encryptedBallot := encryptedVotes at: i.
			share := vc share.
			vc tuples
				with: encryptedBallot
				do: [ :tuple :eb | 
					encryptedVote := self thresholdPublicKey crypt: tuple plain with: tuple r.
					eb greaseString = (share blind: encryptedVote with: self thresholdPublicKey) greaseString
						ifFalse: [ "correct := false" ] ] ].
	^ correct! !

!VOECMBProtocol methodsFor: 'tasks' stamp: 'NicolasVanderAuwera 5/7/2012 07:54'!
checkSignature: aMBUser
	| pk |
	pk := self anonymousCertificate tbsCertificate subjectPublicKeyInfo subjectPublicKey.
	^ (pk crypt: aMBUser signature) greaseString = aMBUser id greaseString! !

!VOECMBProtocol methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 5/7/2012 15:22'!
encryptedVotes
	^ encryptedVotes! !

!VOECMBProtocol methodsFor: 'initialization' stamp: 'NicolasVanderAuwera 11/1/2012 14:15'!
initializeBallots
	ballots := OrderedCollection new.
	CryptographicParameters maxNumberOfBallots timesRepeat: [ ballots add: self election ballot deepCopy ]! !

!VOECMBProtocol methodsFor: 'tasks' stamp: 'NicolasVanderAuwera 7/23/2012 07:39'!
isVoterAlreadyVoted: aMBUser
	| config client |
	config := self configurations at: VOPollingOfficeManager key.
	client := SocketStream openConnectionToHostNamed: config host port: config port.
	client
		sendCommand: #checkuser;
		sendCommand: id greaseString;
		sendCommand: aMBUser id greaseString.
	^ client nextLine = 'true'! !

!VOECMBProtocol methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 5/7/2012 12:56'!
position: anInteger
	position := anInteger! !

!VOECMBProtocol methodsFor: 'network' stamp: 'NicolasVanderAuwera 10/29/2012 16:34'!
requestAnonymousCertificate
	| ca client |
	ca := self configurations at: VOCertificationAuthority key.
	client := SocketStream openConnectionToHostNamed: ca host port: ca port.
	client
		sendCommand: #certificateOf;
		sendObject: (VOAgentX501SubjectInfo country: 'BE' organisation: 'Volunti' organisationUnit: 'Anonymous Authority').
	anonymousCertificate := client receiveObject.
	client close! !

!VOECMBProtocol methodsFor: 'network' stamp: 'NicolasVanderAuwera 7/23/2012 07:38'!
requestThresholdPublicKey
	| stream homomorphicAuth |
	homomorphicAuth := self configurations at: VOHomomorphicManager key.
	stream := SocketStream openConnectionToHostNamed: homomorphicAuth host port: homomorphicAuth port.
	stream
		sendCommand: #thresholdpublickey;
		sendCommand: id greaseString.
	thresholdPublicKey := stream receiveObject.
	stream close! !

!VOECMBProtocol methodsFor: 'tasks' stamp: 'NicolasVanderAuwera 7/23/2012 07:39'!
sendBallots: collection
	| config client |
	config := self configurations at: VOPollingOfficeManager key.
	client := SocketStream openConnectionToHostNamed: config host port: config port.
	client noTimeout.
	client
		sendCommand: #ballots;
		sendCommand: id greaseString;
		sendObject: collection.
	encryptedVotes := client receiveObject.
	client close! !

!VOECMBProtocol methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 5/5/2012 08:41'!
setupTasks
	^ Dictionary new
		at: '1. Registration' put: 'Go to the registration office to get your digipass.';
		at: '2. Become anonymous' put: 'Contact the anonymous authority to become anonymous for the election.';
		at: '3. Get your secret' put: 'Present yourself personally to the Mental Booth office.';
		yourself! !

!VOECMBProtocol methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 5/9/2012 12:53'!
thresholdPublicKey
	thresholdPublicKey ifNil: [ self requestThresholdPublicKey ].
	^ thresholdPublicKey! !

!VOECMBProtocol methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 5/7/2012 07:54'!
userClass
	^ VOMBUser! !

!VOECMBProtocol methodsFor: 'private' stamp: 'NicolasVanderAuwera 2/21/2012 16:57'!
verifyBallot: aBallot
	! !

!VOECMBProtocol methodsFor: 'private' stamp: 'NicolasVanderAuwera 7/23/2012 07:39'!
verifyBallots: collection
	| config client |
	config := self configurations at: VOPollingOfficeManager key.
	client := SocketStream openConnectionToHostNamed: config host port: config port.
	client noTimeout.
	client
		sendCommand: #vote;
		sendCommand: id greaseString;
		sendObject: collection.
	encryptedVotes := client receiveObject.
	client close! !

!VOECProtocol class methodsFor: 'instance creation' stamp: 'NicolasVanderAuwera 1/5/2012 09:42'!
for: anElection
	^ self new election: anElection! !

!VOECProtocol methodsFor: 'network' stamp: 'NicolasVanderAuwera 3/29/2012 13:11'!
authenticate: aUser
	^ aUser! !

!VOECProtocol methodsFor: 'network' stamp: 'NicolasVanderAuwera 5/5/2012 16:48'!
authenticate: aUser for: id
	^ aUser! !

!VOECProtocol methodsFor: 'tasks' stamp: 'NicolasVanderAuwera 7/30/2012 15:06'!
castBallot: aBallot
	| client config |
	config := self configurations at: VOPollingOfficeManager key.
	client := SocketStream openConnectionToHostNamed: config host port: config port.
	client
		sendCommand: #cast;
		sendCommand: aBallot electionId greaseString;
		sendObject: aBallot.
	client close! !

!VOECProtocol methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 5/5/2012 15:54'!
configurations
	configurations ifNil: [ self requestConfigurations ].
	^ configurations! !

!VOECProtocol methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 3/10/2012 10:36'!
election
	^ election! !

!VOECProtocol methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 1/5/2012 09:43'!
election: anElection
	election := anElection! !

!VOECProtocol methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 5/7/2012 09:13'!
id: anInteger
	id := anInteger! !

!VOECProtocol methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 5/8/2012 10:15'!
identificationUser
	identificationUser isNil
		ifTrue: [ identificationUser := self identificationUserClass new ].
	^ identificationUser! !

!VOECProtocol methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 5/8/2012 10:14'!
identificationUserClass
	^ VOUser! !

!VOECProtocol methodsFor: 'testing' stamp: 'NicolasVanderAuwera 1/20/2012 07:46'!
isSimple
	^ false! !

!VOECProtocol methodsFor: 'network' stamp: 'NicolasVanderAuwera 5/5/2012 15:53'!
requestConfigurations
	| client |
	client := SocketStream openConnectionToHostNamed: NetNameResolver localHostName port: VOElectionManager port.
	client sendCommand: #configurations.
	configurations := client receiveObject.
	client close! !

!VOECProtocol methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 3/29/2012 12:58'!
user
	user isNil
		ifTrue: [ user := self userClass new ].
	^ user! !

!VOECProtocol methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 3/29/2012 12:57'!
userClass
	^ VOUser! !

VOECProtocol subclass: #VOECSimpleProtocol
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-ElectionClient-Model'!

!VOECSimpleProtocol methodsFor: 'tasks' stamp: 'NicolasVanderAuwera 7/30/2012 14:43'!
checkSignature: aUser
	^ true! !

!VOECSimpleProtocol methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 7/23/2012 07:39'!
getResultsFor: anId
	| results client |
	client := SocketStream openConnectionToHostNamed: NetNameResolver localHostName port: VOPollingOfficeManager port.
	client sendCommand: 'results'.
	client sendCommand: anId greaseString.
	results := client receiveObject.
	client close.
	^ results! !

!VOECSimpleProtocol methodsFor: 'testing' stamp: 'NicolasVanderAuwera 1/20/2012 07:46'!
isSimple
	^ true! !

!VOECSimpleProtocol methodsFor: 'testing' stamp: 'NicolasVanderAuwera 7/30/2012 14:43'!
isVoterAlreadyVoted: aUser
	^ false! !

!VOECSimpleProtocol methodsFor: 'testing' stamp: 'NicolasVanderAuwera 2/21/2012 14:48'!
notSimple
	^ false! !

!VOECSimpleProtocol methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 5/5/2012 09:31'!
resultsFor: anId
	| results |
	results := self getResultsFor: anId.
	^ results! !

Object subclass: #VOElectionClient
	instanceVariableNames: ''
	classVariableNames: 'ElectionManagerConfiguration Protocols'
	poolDictionaries: ''
	category: 'Volunti-ElectionClient-Model'!

!VOElectionClient class methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 10/29/2012 08:06'!
electionManagerConfiguration
	^ ElectionManagerConfiguration! !

!VOElectionClient class methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 10/29/2012 08:07'!
electionManagerConfiguration: aConfiguration
	ElectionManagerConfiguration := aConfiguration! !

!VOElectionClient class methodsFor: 'initialization' stamp: 'NicolasVanderAuwera 10/29/2012 14:34'!
initialize
	super initialize.
	ElectionManagerConfiguration := VONetworkConfiguration description: 'Election Manager' key: #voelectionmanager! !

!VOElectionClient class methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 8/3/2012 13:51'!
protocols
	^ Dictionary new
		at: #simple put: VOECSimpleProtocol;
		at: #anonymous put: VOECAnonymousProtocol;
		at: #mentalbooth put: VOECMBProtocol;
		at: #alternative put: VOECAlternativeMBProtocol;
		yourself! !

!VOElectionClient methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 11/15/2012 07:40'!
elections
	"return an ordered collection of containers"

	| connection receipt |
	self class electionManagerConfiguration isConfigured
		ifTrue: [ 
			connection := VOConnection configuration: self class electionManagerConfiguration.
			receipt := connection send: VOGetElectionsMessage new.
			receipt ifNil: [ self error: 'Unable to retrieve elections.' ].
			"self processElections: receipt" ].
	^ receipt! !

!VOElectionClient methodsFor: 'private' stamp: 'NicolasVanderAuwera 11/1/2012 14:11'!
processElections: aCollection
	^ aCollection
		do: [ :each | 
			| protocol |
			protocol := (self class protocols at: each protocol) new.
			protocol id: each id.
			each protocol: protocol ]! !
VOElectionClientComponent initialize!
VOMHomePage initialize!
VOElectionClient initialize!
